diff --git a/modules/NUCLEO-F103RB/test/button/module_test_button.c b/modules/NUCLEO-F103RB/test/button/module_test_button.c
index 9990b53..e2914ca 100644
--- a/modules/NUCLEO-F103RB/test/button/module_test_button.c
+++ b/modules/NUCLEO-F103RB/test/button/module_test_button.c
@@ -41,8 +41,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 static aos_test_buttondata_t _data = {
   /* button       */ &moduleLldUserButton,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_USERBUTTON,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_USERBUTTON,
 };
 
 static AOS_TEST(_test, "button", NULL, moduleTestButtonShellCb, aosTestButtonFunc, &_data);
diff --git a/modules/NUCLEO-F401RE/aosconf.h b/modules/NUCLEO-F401RE/aosconf.h
index aa21821..45e6687 100644
--- a/modules/NUCLEO-F401RE/aosconf.h
+++ b/modules/NUCLEO-F401RE/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    MODULE_OS_IOEVENTFLAGS_USERBUTTON
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK MODULE_OS_GPIOEVENTFLAG_USERBUTTON
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_NONE
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +131,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
diff --git a/modules/NUCLEO-F401RE/module.c b/modules/NUCLEO-F401RE/module.c
index 68063b1..bcc71fd 100644
--- a/modules/NUCLEO-F401RE/module.c
+++ b/modules/NUCLEO-F401RE/module.c
@@ -97,9 +97,9 @@ ROMCONST apalControlGpio_t moduleGpioUserButton = {
  */
 /*===========================================================================*/
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 ROMCONST char* moduleShellPrompt = "NUCLEO-F401RE";
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /** @} */
 
diff --git a/modules/NUCLEO-F401RE/module.h b/modules/NUCLEO-F401RE/module.h
index 6f6675c..a3d398c 100644
--- a/modules/NUCLEO-F401RE/module.h
+++ b/modules/NUCLEO-F401RE/module.h
@@ -91,30 +91,29 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
+#define MODULE_OS_GPIOEVENTFLAG_USERBUTTON      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell prompt text.
  */
 extern ROMCONST char* moduleShellPrompt;
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /**
  * @brief   Interrupt initialization macro.
- * @note    SSSP related interrupt signals are already initialized in 'aos_system.c'.
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioUserButton.gpio->line);  \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioUserButton.gpio->line);  \
   palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                  \
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
+  /* add test commands to shell */                                            \
 }
 
 /**
@@ -129,13 +128,14 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Periphery communication interface deinitialization hook.
  */
 #define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
+  /* don't stop the serial driver so messages can still be printed */         \
 }
 
 /**
  * @brief   HOOK to toggle the LEDs when the user button is pressed.
  */
-#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
-  if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
+#define MODULE_MAIN_LOOP_GPIOEVENT(eventflags) {                              \
+  if (eventflags & MODULE_OS_GPIOEVENTFLAG_USERBUTTON) {                      \
     apalControlGpioState_t buttonstate;                                       \
     apalControlGpioGet(&moduleGpioUserButton, &buttonstate);                  \
     apalControlGpioSet(&moduleGpioLed, buttonstate);                          \
@@ -151,6 +151,12 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+// SSSP is not yet supported on this module
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/NUCLEO-F767ZI/aosconf.h b/modules/NUCLEO-F767ZI/aosconf.h
index fc42c7a..0e4ebee 100644
--- a/modules/NUCLEO-F767ZI/aosconf.h
+++ b/modules/NUCLEO-F767ZI/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    MODULE_OS_IOEVENTFLAGS_USERBUTTON
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK MODULE_OS_GPIOEVENTFLAG_USERBUTTON
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_NONE
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +131,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
diff --git a/modules/NUCLEO-F767ZI/module.c b/modules/NUCLEO-F767ZI/module.c
index bb5d9ae..606f1f8 100644
--- a/modules/NUCLEO-F767ZI/module.c
+++ b/modules/NUCLEO-F767ZI/module.c
@@ -127,9 +127,9 @@ ROMCONST apalControlGpio_t moduleGpioUserButton = {
  */
 /*===========================================================================*/
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 ROMCONST char* moduleShellPrompt = "NUCLEO-F767ZI";
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /** @} */
 
diff --git a/modules/NUCLEO-F767ZI/module.h b/modules/NUCLEO-F767ZI/module.h
index 543c763..3cfec3c 100644
--- a/modules/NUCLEO-F767ZI/module.h
+++ b/modules/NUCLEO-F767ZI/module.h
@@ -101,30 +101,29 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
+#define MODULE_OS_GPIOEVENTFLAG_USERBUTTON      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell prompt text.
  */
 extern ROMCONST char* moduleShellPrompt;
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /**
  * @brief   Interrupt initialization macro.
- * @note    SSSP related interrupt signals are already initialized in 'aos_system.c'.
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioUserButton.gpio->line);  \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioUserButton.gpio->line);  \
   palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                  \
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
+  /* add test commands to shell */                                            \
 }
 
 /**
@@ -139,13 +138,14 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Periphery communication interface deinitialization hook.
  */
 #define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
+  /* don't stop the serial driver so messages can still be printed */         \
 }
 
 /**
  * @brief   HOOK to toggle the LEDs when the user button is pressed.
  */
-#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
-  if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
+#define MODULE_MAIN_LOOP_GPIOEVENT(eventflags) {                              \
+  if (eventflags & MODULE_OS_GPIOEVENTFLAG_USERBUTTON) {                      \
     apalControlGpioState_t buttonstate;                                       \
     apalControlGpioGet(&moduleGpioUserButton, &buttonstate);                  \
     apalControlGpioSet(&moduleGpioLed1, buttonstate);                         \
@@ -163,6 +163,12 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+// SSSP is not yet supported on this module
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/NUCLEO-L476RG/aosconf.h b/modules/NUCLEO-L476RG/aosconf.h
index 0bbf321..5b0779e 100644
--- a/modules/NUCLEO-L476RG/aosconf.h
+++ b/modules/NUCLEO-L476RG/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    MODULE_OS_IOEVENTFLAGS_USERBUTTON
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK MODULE_OS_GPIOEVENTFLAG_USERBUTTON
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_NONE
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +131,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
diff --git a/modules/NUCLEO-L476RG/module.c b/modules/NUCLEO-L476RG/module.c
index 5500b4d..2a731e6 100644
--- a/modules/NUCLEO-L476RG/module.c
+++ b/modules/NUCLEO-L476RG/module.c
@@ -107,9 +107,9 @@ ROMCONST apalControlGpio_t moduleGpioUserButton = {
  */
 /*===========================================================================*/
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 ROMCONST char* moduleShellPrompt = "NUCLEO-L476RG";
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /** @} */
 
diff --git a/modules/NUCLEO-L476RG/module.h b/modules/NUCLEO-L476RG/module.h
index dacef7b..1c4b8bf 100644
--- a/modules/NUCLEO-L476RG/module.h
+++ b/modules/NUCLEO-L476RG/module.h
@@ -105,22 +105,21 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
+#define MODULE_OS_GPIOEVENTFLAG_USERBUTTON      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell prompt text.
  */
 extern ROMCONST char* moduleShellPrompt;
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /**
  * @brief   Interrupt initialization macro.
- * @note    SSSP related interrupt signals are already initialized in 'aos_system.c'.
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioUserButton.gpio->line);  \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioUserButton.gpio->line);  \
   palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                  \
 }
 
@@ -128,7 +127,7 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* initialize tests and add to shell */                                     \
+  /* add test commands to shell */                                            \
   aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
   aosShellAddCommand(&aos.shell, &moduleTestButtonShellCmd);                  \
   MODULE_INIT_TEST_MPU6050();                                                 \
@@ -136,7 +135,6 @@ extern ROMCONST char* moduleShellPrompt;
 }
 #if (BOARD_MPU6050_CONNECTED == true)
   #define MODULE_INIT_TEST_MPU6050() {                                        \
-    /* add unit-test shell commands */                                        \
     aosShellAddCommand(&aos.shell, &moduleTestMpu6050ShellCmd);               \
   }
 #else /* (BOARD_MPU6050_CONNECTED == true) */
@@ -185,13 +183,14 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Periphery communication interface deinitialization hook.
  */
 #define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
+  /* don't stop the serial driver so messages can still be printed */         \
 }
 
 /**
  * @brief   HOOK to toggle the LEDs when the user button is pressed.
  */
-#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
-  if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
+#define MODULE_MAIN_LOOP_GPIOEVENT(eventflags) {                              \
+  if (eventflags & MODULE_OS_GPIOEVENTFLAG_USERBUTTON) {                      \
     button_lld_state_t buttonstate;                                           \
     button_lld_get(&moduleLldUserButton, &buttonstate);                       \
     led_lld_set(&moduleLldLed, (buttonstate == BUTTON_LLD_STATE_PRESSED) ? LED_LLD_STATE_ON : LED_LLD_STATE_OFF); \
@@ -207,6 +206,12 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+// SSSP is not yet supported on this module
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/NUCLEO-L476RG/test/button/module_test_button.c b/modules/NUCLEO-L476RG/test/button/module_test_button.c
index 9990b53..e2914ca 100644
--- a/modules/NUCLEO-L476RG/test/button/module_test_button.c
+++ b/modules/NUCLEO-L476RG/test/button/module_test_button.c
@@ -41,8 +41,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 static aos_test_buttondata_t _data = {
   /* button       */ &moduleLldUserButton,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_USERBUTTON,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_USERBUTTON,
 };
 
 static AOS_TEST(_test, "button", NULL, moduleTestButtonShellCb, aosTestButtonFunc, &_data);
diff --git a/modules/PowerManagement_1-1/aosconf.h b/modules/PowerManagement_1-1/aosconf.h
index 20eab3e..968bbf6 100644
--- a/modules/PowerManagement_1-1/aosconf.h
+++ b/modules/PowerManagement_1-1/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    0
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK 0
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,21 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_AMiRoBLT
+
+/** @} */
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +133,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
